import java.io.*;
//{{{  Heading
/**
 * Written by yvind Teig, 1. May 1996
 * Oyvind.Teig@autronica.telemax.no
 */
//}}}  
public class ComsTime_a extends Thread
{
   private PipedInputStream  in_stream;
   private PipedOutputStream out_stream;
   private int               work_loop_down_counter;
   private int               token_start_value;

   //{{{  ComsTime_a
   ComsTime_a (
      PipedInputStream  an_in_stream,
      PipedOutputStream an_out_stream,
      int               a_work_loop_down_counter,
      int               a_token_start_value)
   {
      setName ("ComsTime_a");
      in_stream              = an_in_stream;
      out_stream             = an_out_stream;
      work_loop_down_counter = a_work_loop_down_counter;
      token_start_value      = a_token_start_value;
      start ();
   }
   //}}}  
   //{{{  run
   public void  run ()
   {
      // System.out.println ("    " + getName() + " " + toString());
      // System.out.println (currentThread().toString());
      try
      {
         out_stream.write (token_start_value);  // starts it all
         int token = 1;
         while (token > 0)
         {
            token = in_stream.read ();
            // System.out.println ("    " + getName() + " " + token);
            out_stream.write (token);
            //{{{  work_loop_down_counter
            int cnt = work_loop_down_counter;
            while (cnt > 0) {cnt = cnt - 1;}
            //}}}  
         }
      }
      catch (IOException caught)
      {
         System.out.println ("    " + getName() + " method run exception");
      }
   }
   //}}}  
}
