import java.io.*;
//{{{  Heading
/**
 * Written by yvind Teig, 1. May 1996
 * Oyvind.Teig@autronica.telemax.no
 */
//}}}  
public class ComsTime_b extends Thread
{
   private PipedInputStream  in_stream;
   private PipedOutputStream out_stream;
   private PipedOutputStream out_stream_report;
   private int               work_loop_down_counter;

   //{{{  ComsTime_b
   ComsTime_b (
      PipedInputStream  an_in_stream,
      PipedOutputStream an_out_stream,
      PipedOutputStream an_out_stream_report,
      int               a_work_loop_down_counter)
   {
      setName ("ComsTime_b");
      in_stream              = an_in_stream;
      out_stream             = an_out_stream;
      out_stream_report      = an_out_stream_report;
      work_loop_down_counter = a_work_loop_down_counter;
      start ();
   }
   //}}}  
   //{{{  run
   public void  run ()
   {
      // System.out.println ("    " + getName() + " " + toString());
      // System.out.println (currentThread().toString());
      try
      {
         int token = 1;
         while (token > 0)
         {
            token = in_stream.read ();
            // System.out.println ("    " + getName() + " " + token);
            //{{{  Pass on to  other(s)
            if
               (token > 0)
               {
                  //{{{  Start new threads, let them work and terminate
                  ComsTime_buffer aBuffer_b1 = new ComsTime_buffer (token, out_stream_report);
                  ComsTime_buffer aBuffer_b2 = new ComsTime_buffer (token, out_stream);

                  try
                  {
                     aBuffer_b1.join ();
                     aBuffer_b2.join ();
                  }
                  catch (InterruptedException caught)
                  {
                     System.out.println ("    " + getName() + " method run exception");
                  }
                  //}}}  
               }
            else
               if (token == 0)
               {
                  //{{{  Start new thread, let it work and terminate
                  ComsTime_buffer aBuffer_b1 = new ComsTime_buffer (token, out_stream_report);

                  try
                  {
                     aBuffer_b1.join ();
                  }
                  catch (InterruptedException caught)
                  {
                     System.out.println ("    " + getName() + " method run exception");
                  }
                  //}}}  
               }
            //}}}  
            //{{{  work_loop_down_counter
            int cnt = work_loop_down_counter;
            while (cnt > 0) {cnt = cnt - 1;}
            //}}}  
         }
      }
      catch (IOException caught)
      {
         System.out.println ("    " + getName() + " method run exception");
      }
   }
   //}}}  
}
